// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Drag.java
// Simple agent that just follows the mouse.
// ------------------------------------------------------------------------------

class Drag extends Model
{
  float invSpeed;
   
  /**
   * Constructor
   */
  Drag(String N, Polygon P, Material M, Point C, float R, Settings S, String I)
  {
    super(N, "Drag", P, M, C, R, S, I);
  }
   
  /**
   * Executes one frame
   */
  Model frame(ArrayList models, boolean[] keys)
  {
    Model camera = findCamera(models);
    Vector difference = new Vector((mouseX - width/2)/settings.PIXELS_PER_METER - center.x + camera.center.x, (mouseY - height/2)/settings.PIXELS_PER_METER - center.y + camera.center.y);
    center = difference.multiply(1/invSpeed).add(center);
    return this;
  }
  
  /**
   * Parse the input string. This agent doesn't
   * take in any arguments.
   */
  void parseInput(String input)
  {
    String[] args = inputToArray(input);
    
    invSpeed = Str2Flt(args[0]);
  }
  
  /**
  * Finds the camera in the list of models
  */
  Model findCamera(ArrayList models)
  {
    return (Model) models.get(0);
  }
}
