// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Interval.java
// Data type for simple 1 dimensional hyper-planes.
// ------------------------------------------------------------------------------

class Interval
{
  float min;
  float max;
    
  /**
   * Constructor
   */
  Interval(float Min, float Max)
  {
    min = Min;
    max = Max;
  }
  
  /**
   * Update the interval
   */
  void insert(float value)
  {
    if (value > max)
    {
      max = value;
    }
    else if (value < min)
    {
      min = value;
    }
  }
  
  /**
   * Offset the interval
   */
  Interval offset(float c)
  {
    Interval R = new Interval(0,0);
    R.min = min + c;
    R.max = max + c;
    return R;
  }
  
  /**
   * Find the intersection of two intervals
   */
  Interval intersect(Interval I)
  {
    Interval R;
    
    if ((min <= I.max && min >= I.min) || (I.min <= max && I.min >= min))
    {
        R = new Interval(max(min, I.min),min(max, I.max));
    }
    else
    {
      R = new Interval(0,0);
    }
    
    return R;
  }
  
  /**
   * Length of the interval
   */
  float length()
  {
    return max-min;
  }
}
