// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Particle.java
// An abstract type for the special effects in the game world. This includes smoke,
// sparks, flashes, etc.
// ------------------------------------------------------------------------------

abstract class Particle
{
  float rotation;
  Point center;
  Vector veloc;
  Vector accel;
  boolean dead;
  boolean renderOnTop;
  
  /**
   * Constructor
   */
  Particle(float R, Point C, Vector V, boolean O)
  {
    rotation = R;
    center = C;
    veloc = V;
    accel = new Vector();
    renderOnTop = O;
  }
  
  /**
   * Kills the particle
   */
  void die()
  {
    dead = true;
  }
  
  /**
   * Each particle should be able to
   * update its position after each frame
   */
  abstract void frame();
  
  /**
   * Each particle should be able to
   * draw itself
   */
  abstract void render(float x, float y);
}
