// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Sheep.java
// The sheep that the human plays with.
// ------------------------------------------------------------------------------

class SheepDispenser extends Model
{
  int frame;
  int numSheepCurrent;
  int numSheep;
  int sheepDelay;
  Polygon sheepPolygon;
  Material sheepMaterial;
  
  /**
   * Constructor
   */
  SheepDispenser(String N, Polygon P, Material M, Point C, float R, Settings S, String I)
  {
    super(N, "SheepDispenser", P, M, C, R, S, I);
    
    DataLoader dataLoader = new DataLoader();
    sheepPolygon = dataLoader.loadPolygon("tinyBox");
    sheepMaterial = dataLoader.loadMaterial("wool");
  }
  
  /**
   * Executes one frame
   */
  Model frame(ArrayList models, boolean[] keys)
  {
    frame++;
    
    if (numSheepCurrent < numSheep && frame%sheepDelay == 0)
    {
      addModel(new Sheep("sheep", sheepPolygon, sheepMaterial, center, 0, settings, "initialVelocRange=50&neighbourRadius=50&neighbourSeparateRadius=20&separateK=35&stickK=6&wanderK=20"));
      numSheepCurrent++;
    }
    
    return this;
  }
   
  /**
   * Parse the input string
   */
  void parseInput(String input)
  {
    String[] args = inputToArray(input);
     
    numSheep = Str2Int(args[0]);
    sheepDelay = Str2Int(args[1]);
  }
}
  
